package cologne.eck.all_peas.cloud.provider;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;

import cologne.eck.all_peas.cloud.StorageProvider;
import cologne.eck.all_peas.vm_specific.JREBridge;
import cologne.eck.all_peas.vm_specific.JREProperties;
import cologne.eck.tools.TestLog;
import cologne.eck.tools.UnexpectedValueException;



public class ProviderTester {
	
    private static final String FILE_CONTENT_STRING = "TEST";
    // relative path:
    private static final String TEST_FILE_NAME = "test/cologne/eck/test_files/test.txt";
    
    private static File testFile;

	public ProviderTester() {
		// TODO Auto-generated constructor stub
	}

	public static void main(String[] args) {
		
		JREProperties.setVmBridge(new JREBridge());
		// TODO set CloudFileModel...
		
		URL url = null;
		try {
			url = new URL("https://www.wikipedia.org/");
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (url == null) {
			TestLog.e(ProviderTester.class, "ProviderTester url is null");
			return;
		}
        URLConnection conn;
		try {
			conn = url.openConnection();
	        conn.connect();
	        conn.getInputStream().close();
	        TestLog.v(ProviderTester.class, "Internet connection exists...");
		} catch (IOException e) {
			TestLog.e(ProviderTester.class, "No internet connection...");
			return;
		}

		
/*		final HttpClientBuilder builder = HttpClientBuilder.create();
		Sardine sardine = new SardineImpl(builder);
		final String url = String.format("http://test.cyberduck.ch/dav/anon/sardine/%s", UUID.randomUUID().toString());
		try {
			sardine.put(url, new ByteArrayInputStream("TEST".getBytes()));
			InputStream in = 
					sardine.get(url);
			if (in != null) {
				byte[] b = new byte[4];	
				in.read(b);
				TestLog.v(ProviderTester.class, "in: " + new String(b));
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
		//final InputStream in = sardine.get(url);
		


		
/*		TestLog.v(ProviderTester.class, "============dlp:");
		WebDavProvider test = new WebDavProvider("dlp", null);
		test.setUserName("www.dlp-test.com\\WebDAV");
		test.setUserPassword("WebDAV".toCharArray());
	//	ncp.setServerAddress("https://eck.cologne/klaut");
		// also works with owncloud path...
		test.setWebDavBasePath("https://www.dlp-test.com/webdav");// /USER:www.dlp-test.com\\WebDAV WebDAV");
		test(test);
*/
		
		
		// NiHao NO
/*		TestLog.v(ProviderTester.class, "============ NiHao Seafile:");
		//  Server URL: https://myserver:port
		WebDavProvider seafile1 = new WebDavProvider();
		seafile1.setUserName("lexa-vdb@gmx.de");
		seafile1.setUserPassword("beloumi2367N$".toCharArray());
		//seafile1.setWebDavBasePath("https://app.nihaocloud.com/seafdav");
		//seafile1.setWebDavBasePath("https://nihaocloud.com/seafdav");
		seafile1.setWebDavBasePath("https://app.nihaocloud.com/#my-libs/");
	//	seafile1.setWebDavBasePath("https://nihaocloud.com/#my-libs/");
	//	seafile1.setWebDavBasePath("https://app.nihaocloud.com/#my-libs/");
		seafile1.setProviderName("NiHao");
		test(seafile1);
		
		
		TestLog.v(ProviderTester.class, "============ YourSecureCloud Seafile:");
		//  Server URL: https://myserver:port
		WebDavProvider seafile2 = new WebDavProvider();
		seafile2.setUserName("test@yoursecurecloud.de");
		seafile2.setUserPassword("YSC-2014".toCharArray());
		//seafile1.setWebDavBasePath("https://app.nihaocloud.com/seafdav");
		//seafile1.setWebDavBasePath("https://nihaocloud.com/seafdav");
		seafile2.setWebDavBasePath("https://yoursecurecloud.de/seafdav/#my-libs");
	//	seafile1.setWebDavBasePath("https://nihaocloud.com/#my-libs/");
	//	seafile1.setWebDavBasePath("https://app.nihaocloud.com/#my-libs/");
		seafile2.setProviderName("YourSecureCloud");
		test(seafile2);*/
		
	/*	TestLog.v(ProviderTester.class, "============ luckycloud:");
		//  Server URL: https://myserver:port
		WebDavProvider seafile3 = new WebDavProvider();
		seafile3.setUserName("demo@luckycloud.de");
		seafile3.setUserPassword("q1w2e3R4".toCharArray());
	//	seafile3.setWebDavBasePath("https://luckycloud.de/de/user/seafdav/");//302
	//	seafile3.setWebDavBasePath("https://luckycloud.de/de/user/seafdav/#my-libs/"); // 302
	//	seafile3.setWebDavBasePath("https://luckycloud.de/seafdav/"); // 302
	//	seafile3.setWebDavBasePath("https://storage.luckycloud.de/seafdav/");// 404
		seafile3.setWebDavBasePath("https://storage.luckycloud.de/#my-libs/seafdav/");// 403 forbidden
	//	seafile3.setWebDavBasePath("https://storage.luckycloud.de/");// 404 not found
		seafile3.setProviderName("lucky");
		test(seafile3);*/
		
		/**
		 * authorize, 
		 * check if folder "Test" exists,
		 * upload file "text.txt"
		 * check if file exists, 
		 * download file
		 */
		// NextCloud OK
/*		TestLog.v(ProviderTester.class, "============eck.cologne:");
		WebDavProvider ncp = new WebDavProvider("eck");
		ncp.setUserNameX("Beloumix");
		ncp.setUserPasswordX("belH$$$HatschNC".toCharArray());
	//	ncp.setServerAddress("https://eck.cologne/klaut");
		// also works with owncloud path...
		ncp.setWebDavBasePath("https://eck.cologne/klaut/remote.php/webdav");
		test(ncp);*/
		
		// Woelkli OK
		TestLog.v(ProviderTester.class, "============Woelkli:");
		WebDavProvider ncp = new WebDavProvider("woelkli");
		ncp.setUserNameX("lexa-vdb@gmx.de");
		ncp.setUserPasswordX("beloumi2367W$".toCharArray());
		ncp.setWebDavBasePath("https://cloud.woelkli.com/remote.php/webdav");
		test(ncp); 
				
		// Not NextCloud providers:

		// GMX  OK
		TestLog.v(ProviderTester.class, "============ GMX:");
		//  Server URL: https://myserver:port
		WebDavProvider p1 = new WebDavProvider("GMX");
		p1.setUserNameX("lexa-vdb@gmx.de");
		p1.setUserPasswordX("Gask&iktidarsizlik".toCharArray());
		//p.setWebDavBasePath("https://webdav.mediacenter.gmx.net");
		p1.setWebDavBasePath("https://webdav.mc.gmx.net/");
		p1.setProviderName("GMX");
		test(p1);
		
		// pCloud  OK
		TestLog.v(ProviderTester.class, "============ pCloud:");
		WebDavProvider p2 = new WebDavProvider("pCloud");
		p2.setUserNameX("lexa-vdb@gmx.de");
		p2.setUserPasswordX("beloumi2367P$".toCharArray());
		p2.setWebDavBasePath("https://webdav.pcloud.com/");
		p2.setProviderName("pCloud");
		test(p2);
		
		// OpenDrive  OK
		TestLog.v(ProviderTester.class, "============ OpenDrive:");
		WebDavProvider p3 = new WebDavProvider("OpenDrive");
		p3.setUserNameX("lexa-vdb@gmx.de");
		p3.setUserPasswordX("beloumi2367O$".toCharArray());
		p3.setWebDavBasePath("https://webdav.opendrive.com/");
		p3.setProviderName("OpenDrive");
		test(p3);		
		
		// Yandex  OK
		TestLog.v(ProviderTester.class, "============ Yandex:");
		WebDavProvider p4 = new WebDavProvider("Yandex");
		p4.setUserNameX("lexabrruch");
		p4.setUserPasswordX("beloumi2367Y$".toCharArray());
		p4.setWebDavBasePath("https://webdav.yandex.com/");
		p4.setProviderName("Yandex");
		test(p4);				
		
		
		
//NO		// Owncloud Wint.global
/*		TestLog.v(ProviderTester.class, "============Wint.global owncloud:");
		WebDavProvider p = new WebDavDummyProvider();
		p.setUserName("lexa-vdb@gmx.de");
		p.setUserPassword("beloumi2367$O".toCharArray());
	//	p.setWebDavBasePath("https://ocloud.global/remote.php/webdav/");
	//	p.setWebDavBasePath("https://wint.global/customer/remote.php/webdav/");
		p.setWebDavBasePath("https://login.wint.global/clientarea.php/webdav/");
		test(p); */
		
/* NO
		TestLog.v(ProviderTester.class, "============ Cozy:");
		//  Server URL: https://myserver:port
		WebDavProvider p = new WebDavDummyProvider();
		p.setUserName("beloumix");
		p.setUserPassword("beloumi2367$C".toCharArray());
	//	p.setWebDavBasePath("https://beloumix.mycozy.cloud/");
		//p.setWebDavBasePath("https://mycozy.cloud:443");
		p.setProviderName("Cozy");
		//p.setWebDavBasePath("https://mycozy.cloud");
		p.setWebDavBasePath("https://beloumix.mycozy.cloud/remote.php/webdav/");
		test(p);
		*/
		// Box	NO
/*		TestLog.v(ProviderTester.class, "============ Box:");
		WebDavProvider p = new WebDavDummyProvider();
		p.setUserName("lexa-vdb@gmx.de");// AxelBruch
		p.setUserPassword("Hatschepsut2367Box".toCharArray());// Hatschepsut2367Box
		//p.setWebDavBasePath("https://webdav.mediacenter.gmx.net");
		p.setWebDavBasePath("https://dav.box.com/dav/");
		p.setProviderName("Box");
		test(p);
		*/
		// Koofr funktioniert nur, wenn kein Ordner PeaFactory existiert...
		//https://app.koofr.net/dav/Koofr/PeaFactory
	/*			TestLog.v(ProviderTester.class, "============ Koofr.net:");
				WebDavProvider p = new WebDavDummyProvider();
				p.setUserName("lexa-vdb@gmx.de");// AxelBruch
				p.setUserPassword("kcsp w46o 7691 cpqb".toCharArray());// 
				//p.setWebDavBasePath("https://webdav.mediacenter.gmx.net");
				p.setWebDavBasePath("https://app.koofr.net/dav/Koofr/");
				p.setProviderName("Koofr");
				test(p); 
				*/		
		
	
		

		
	}
	
	public static boolean test(WebDavProvider provider) {

		if (provider.authorize(null, null, null) != null) {
			TestLog.e(ProviderTester.class, "failed...");
			return false;
		}
		String error = null;
		if ( provider.fileExists("PeaFactory") != null) {
			TestLog.v(ProviderTester.class, "Create folder PeaFactory...");
			error = provider.createDirectory("PeaFactory");
			if (error != null) {
				TestLog.e(ProviderTester.class, "Failed to create PeaFactory");
				TestLog.e(ProviderTester.class, error);
				return false;
			} else {
				TestLog.v(ProviderTester.class, "Directory PeaFactory successfully created");
			}
		} else {
			TestLog.v(ProviderTester.class, "Folder PeaFactory exists");
		} 
		// Now, always use the folder PeaFactory:
		provider.setWebDavBasePath(provider.getWebDavBasePath() + StorageProvider.peaDirectory + "/");
		
		if (provider.fileExists("Test") !=  null) {
			TestLog.v(ProviderTester.class, "Create folder Test...");
			error = provider.createDirectory("Test");
			if (error != null) {
				TestLog.e(ProviderTester.class, error);
				return false;
			} else {
				TestLog.v(ProviderTester.class, "Folder Test successfully created...");
			}
		} else {
			TestLog.v(ProviderTester.class, "Folder PeaFactory/Test exists");
		}
		
		
		// create test files:
        try {
        	Files.write(Paths.get(TEST_FILE_NAME), 
        			FILE_CONTENT_STRING.getBytes(StandardCharsets.UTF_8),
        			//lines, 
        			//StandardCharsets.UTF_8,
                    StandardOpenOption.CREATE, 
                    StandardOpenOption.TRUNCATE_EXISTING);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        testFile = new File(TEST_FILE_NAME);
        if (testFile.exists() == false) {
        	new UnexpectedValueException("File", "testFile","does not exist...").printDescription();
        }

		
	/*	String testFileName = "/home/axl/Test/test.txt";
		File testFile = new File(testFileName);
		if (testFile.exists() == false) {
			TestLog.e(getClass(), "Missing testFile: " + testFile.getAbsolutePath());
			return false;
		}*/
		File[] files = {testFile};
		error = provider.uploadFiles(files, "Test");
		TestLog.v(ProviderTester.class, "upload " + files[0].getAbsolutePath() );
		if (error !=  null) {
			TestLog.e(ProviderTester.class, error);
			return false;
		}		
		error = provider.lockFileX("Test/test.txt" );
		TestLog.v(ProviderTester.class, "locked: " + "Test/test.txt");
		if (error !=  null) {
			TestLog.e(ProviderTester.class, error);
			return false;
		}
		error = provider.fileExists("Test/test.txt");
		if (error !=  null) {
			TestLog.e(ProviderTester.class, "File wasn't locked: " + "Test/test.txt");
			return false;
		}
		error = provider.openFile("Test/test.txt", "/home/axl/Test/");
		if (error !=  null) {
			TestLog.e(ProviderTester.class, "locked file was opened: " + "Test/test.txt");
			//return false;
		} else {
			TestLog.e(ProviderTester.class, "Not opened: " + "Test/test.txt");
		}

		error = provider.unlockAllX();
		if (error !=  null) {
			TestLog.e(ProviderTester.class, error);
			return false;
		}
		TestLog.v(ProviderTester.class, "Unlocked...");
		
		//String url = ncp.getWebDavBasePath();// + PeaFactory
		//TestLog.v(ProviderTester.class, url + "\n exists: " + ncp.fileExists(url));
		String[] fileNames = provider.getCloudFiles(null);
		TestLog.v(ProviderTester.class, fileNames.length + " files on server");

		String fileNameToDownload = "Test/test.txt";
		TestLog.v(ProviderTester.class, fileNameToDownload + "\n exists: " + provider.fileExists(fileNameToDownload));
		TestLog.v(ProviderTester.class, "last modified: " + provider.lastModified(fileNameToDownload));
		
		String[] cloudFileNames = {"Test/test.txt"};
		TestLog.v(ProviderTester.class, "Download file...");
		error = provider.downloadFiles(cloudFileNames, "/home/axl/");
		if (error !=  null) {
			TestLog.e(ProviderTester.class, error);
			return false;
		}
		boolean exists = testFile.exists();
		TestLog.v(ProviderTester.class, "File /home/axl/Test/test.txt exists: " + exists);

		return true;
	}

}
