package start;

/* Automatically produced file */
/* This class is newly created for each PEA */

import java.io.*;
import javax.swing.JOptionPane;
import cologne.eck.all_peas.data.*;
import cologne.eck.all_peas.vm_specific.JREBridge;
public class Start {

private static final int MEMORY = 16;
private static final String CLASS_NAME = "calendar_pea/control/CalendarPEAControl";
private static final String JAR_FILE_NAME = "calendar";
private final static int FIXED_MEMORY = 550;
private final static int NEEDED_MEMORY = MEMORY + FIXED_MEMORY;
private static double requiredJavaVersion = 1.8;
private static Runtime run = Runtime.getRuntime();
private static String mode = "";

public static void main(String[] args) {

// check mode:
if (args.length > 0) {
  if (args[0] != null) {
    if(args[0].equals("-r") || args[0].equals("-t")){// -r is rescue -t ist test mode
      mode = args[0];// pass parameter to command later
    } 
  } 
}

String command = "java ";// create the program call 
// check memory:
if ( ( NEEDED_MEMORY * 1024 *1024) > run.maxMemory() ) {
  command = command +  "-Xmx" + NEEDED_MEMORY + "m ";}
else { command = command + "-Xms" + NEEDED_MEMORY + "m "; }
PeaProperties.setVmBridge(new JREBridge());
// check java version:
String javaVersionString = null;
try {
  javaVersionString = System.getProperty("java.version");
  double javaVersion = Double.parseDouble( javaVersionString.substring(0,3) );
  if (javaVersion < requiredJavaVersion) {
    JOptionPane.showMessageDialog(null,
    "Wrong java version. Required java version: " + requiredJavaVersion + ", available: "+ System.getProperty("java.version"),
    null, JOptionPane.ERROR_MESSAGE);
    System.exit(1); }
} catch (Exception e) {
   System.err.println("Could not check java version: " + System.getProperty("java.version"));
   System.err.println("Warning: The used version may be inappropriate...");
}

// check if there is an instance of this program already running:
boolean warn = false;
// check for windows and unix:
String OS = System.getProperty("os.name").toLowerCase();

String procs = "";
if (OS.contains("windows")){
  String line;
//  boolean firstOccurence = false;
  try { // read processes, look for this PEA 
    Process procCheckWin = Runtime.getRuntime().exec("wmic PROCESS where \"name like '%java%'\" get Processid,Caption,Commandline");
    BufferedReader inputCheckWin = new BufferedReader(new InputStreamReader(procCheckWin.getInputStream()));
    while ((line = inputCheckWin.readLine()) != null) {
      if(line.contains(JAR_FILE_NAME + ".jar")){
        System.out.println( line);
        procs = procs + line + "\n";
        //System.out.println( line);
         if (line.contains("Files\\Oracle\\Java\\javapath\\")){
           continue;
        } else {
           if(line.contains("-Xms")){
             warn = true;
             System.out.println( "instance already running");
             break;
           } else {
             //firstOccurence = true;// this is only the instance of this start program
           }
        }
      }
    }
    inputCheckWin.close();
  } catch (IOException ioe) {
JOptionPane.showMessageDialog(null, ioe.toString() + " - check process failed");
    ioe.printStackTrace();
}

} else { // should work for most Unix: Linux, BSD, Solaris, Mac OS except OS X 
  try {//  
    Process checkPro = run.exec("pgrep -f "+ JAR_FILE_NAME + ".jar");
    checkPro.waitFor();
    BufferedReader buffCheck = new BufferedReader(new InputStreamReader(checkPro.getInputStream()));
    buffCheck.readLine(); // this is always existent: the ID of this process
    int checkProID = Integer.parseInt(buffCheck.readLine()); // next line: there should be no ID
    //TestLog.o(Start.class, checkProID);
    if( checkProID > 100){
      System.out.println("" + checkProID);
      procs = procs + "Process: " + checkProID + "\n";
      warn = true;
      System.out.println( "instance already running");
       buffCheck.close();
    }
  } catch (NumberFormatException e) { 
    // thats ok, there is not such process
	 // JOptionPane.showMessageDialog(null, e.toString() + " - check process failed");
    //TestLog.o(Start.class, "no instance running");
  } catch (Exception e) { 
JOptionPane.showMessageDialog(null, e.toString() + " - check process failed");
    //... this will be thrown for rarely used systems with no pgrep
  }
}

if(warn == true){ 
  Object[] options = {PeaProperties.getVmBridge().translate("start_nevertheless"), PeaProperties.getVmBridge().translate("cancel")};
  int n = JOptionPane.showOptionDialog(null,
    PeaProperties.getVmBridge().translate("running_instance") + "\n" + procs,
    PeaProperties.getVmBridge().translate("warning"), JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE, null, 
    options, options[1]);
  if(n != 0) { System.exit(0);}
}

// create the command:
// use nohup for file PEA and Linux to encrypt opened files when closing the terminal
if(CLASS_NAME.contains("file_pea") && OS.contains("linux")){ 
   command = "nohup " + command;
}command =  command + "-cp " + JAR_FILE_NAME 
+ ".jar cologne.eck." + CLASS_NAME + " " + mode;

try {
  // run the program
   Process p = run.exec(command);
   System.out.println(JAR_FILE_NAME);
   try {
      // Redirect  standard streams:
      //System.out.println("Redierect streams...");
      String line;
   ////   BufferedReader bri = new BufferedReader(new InputStreamReader(p.getInputStream()));
      BufferedReader bre = new BufferedReader(new InputStreamReader(p.getErrorStream()));
   ////   while ((line = bri.readLine()) != null) { System.out.println(line); }
   ////   bri.close();
      while ((line = bre.readLine()) != null) { System.out.println(line); }
      bre.close();
   ////   p.waitFor();
   } catch (Exception ue) { 
      System.err.println(ue.getLocalizedMessage() + " - " + ue.toString()); 
   }
   System.exit(0);
} catch (IOException ie) {
  JOptionPane.showMessageDialog(null,
  "Execution failed."
  + ie.toString(),
  null,JOptionPane.ERROR_MESSAGE);
  ie.printStackTrace();
  System.exit(0);
} catch (Exception ire) { // InterruptedException  //for terminal only
  JOptionPane.showMessageDialog(null,
  "Execution failed."
  + ire.toString(),
  null,JOptionPane.ERROR_MESSAGE);
  ire.printStackTrace();
  System.exit(0);
} finally{    System.exit(0);
}}}
